/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

/*
 * MOTIF and X include files needed for widget
 * creation and toolkit initialization.
 */
#include <Xm/Xm.h>
#include "creation.h"
#include <gl/gl.h>
#include <gl/device.h>
#include <gl/image.h>

/* start VL includes */
#include <X11/Xlib.h>   /* for XEvent */
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <Xm/MwmUtil.h>

#include <vl/vl.h>
#include <vl/dev_ev1.h>

#include <gl/gl.h>
#include <gl/device.h>
/* end VL includes */

/* Application name and class definition. */
#define BX_APP_NAME "specialfx"
#define BX_APP_CLASS "Specialfx"

/* Shell callback procedure declarations */
extern void uminScaleHandler();
extern void umaxScaleHandler();
extern void vminScaleHandler();
extern void vmaxScaleHandler();
extern void chromasharpHandler();
extern void chromasharpScaleHandler();
extern void chromaDoPBHandler();
extern void chromaAPBHandler();
extern void chromaBPBHandler();
extern void chroma1PBHandler();
extern void chroma2PBHandler();
extern void chroma3PBHandler();
extern void chroma4PBHandler();
extern void chromasetTBHandler();
extern void yminScaleHandler();
extern void ymaxScaleHandler();
extern void lumasharpScaleHandler();
extern void lumafgopScaleHandler();
extern void lumaDoHandler();
extern void lumaAPBHandler();
extern void lumaBPBHandler();
extern void luma1PBHandler();
extern void luma2PBHandler();
extern void luma3PBHandler();
extern void luma4PBHandler();
extern void lumasetTBHandler();
extern void leftrightswitchPBHandler();
extern void elevatorhorizswitchPBHandler();
extern void crossswitchPBHandler();
extern void rectoutswitchPBHandler();
extern void upperleftswitchPBHandler();
extern void squaresswitchPBHandler();
extern void tilesswitchPBHandler();
extern void fadeswitchPBHandler();
extern void automanualTBHandler();
extern void switchspeedScaleHandler();
extern void fuzzScaleHandler();
extern void manualScaleHandler();
extern void repeatScaleHandler();
extern void util1PBHandler();
extern void util2PBHandler();
extern void helpPBHandler();
extern void quitPBHandler();
extern void option1PBHandler();
extern void app1PBHandler();
extern void app2PBHandler();
extern void app3PBHandler();
extern void app4PBHandler();
extern void app5PBHandler();
extern void app6PBHandler();
extern void grabnsavePBHandler();
extern void grabndispPBHandler();
extern void vidovergfxPBHandler();
extern void gfxovervidPBHandler();
extern void fullscreenoutPBHandler();

/* Function prototypes for convenience routines
 * located in utilities file.
 */
extern XtPointer CONVERT();
extern void RegisterBxConverters();

/* Forward declaration of widget create routines,
 * usually located in the creation file.
 */
Widget CreatemainWindow();
Widget CreatechromaBBoard();
Widget CreatelumaBBoard();
Widget CreateswitchBBoard();
Widget CreatechromaShell();
Widget CreatelumaShell();
Widget CreateswitchShell();

/*
 * Global Widget variable declarations.
 */
Widget AppShell; /* The Main Application Shell */
Widget Shell000;
Widget MainWindow;
Widget Shell001;
Widget ChromaBBoard;
Widget Shell002;
Widget LumaBBoard;
Widget Shell003;
Widget SwitchBBoard;

/* ----- add variable and widget globals here:      */
/*       the externs are in creation.h              */
/*       The globals start w/a capital letter       */

/* from chroma widget: */
Widget UminTF;
Widget UmaxTF;
Widget VminTF;
Widget VmaxTF;
Widget ChromasharpTF;
Widget UminScale;
Widget UmaxScale;
Widget VminScale;
Widget VmaxScale;
Widget ChromasharpScale;
Widget ChromasetTB;
Widget UrangelockTB;
Widget VrangelockTB;

/* from luma widget: */
Widget YminTF;
Widget YmaxTF;
Widget LumasharpTF;
Widget LumafgopTF;
Widget YminScale;
Widget YmaxScale;
Widget LumasharpScale;
Widget LumafgopScale;
Widget LumasetTB;
Widget YrangelockTB;

/* from switch Widget: */
Widget ManualScale;
Widget FuzzScale;
Widget SwitchspeedScale;

/* preset memory on the chroma and luma widgets */
int ChromaPreA[5] = {37, 144, -136, 111, 6};
int ChromaPreB[5] = {0, 0, 0, 0, 0};
int ChromaPre1[5] = {0, 0, 0, 0, 0};
int ChromaPre2[5] = {0, 0, 0, 0, 0};
int ChromaPre3[5] = {0, 0, 0, 0, 0};
int ChromaPre4[5] = {0, 0, 0, 0, 0};
int LumaPreA[4] = {0, 18, 7, 255};
int LumaPreB[4] = {165, 255, 7, 255};
int LumaPre1[4] = {0, 0, 0, 255};
int LumaPre2[4] = {0, 0, 0, 255};
int LumaPre3[4] = {0, 0, 0, 0};
int LumaPre4[4] = {0, 0, 0, 0};

Boolean Urangelock = False;
Boolean Vrangelock = False;
Boolean Yrangelock = False;
int	Urangelockval = 0;
int	Vrangelockval = 0;
int	Yrangelockval = 0;

Boolean Automanualswitch = True;
int	ev1num = -1; /* the device number to be used for ev1 */

/* ----- end add globals */

